// ---------------------------------------------------------------------
// MyLinkedList.h
//
// Written by Brent Dingle
// Last Modified: 2013
//
// Example of a linked list and its associated Node type
// Technically class Node should be declared separately
// using its own header and .cpp file
// We will use it as struct for the most part
// ---------------------------------------------------------------------
#pragma once

#include <iostream>
#include <string>

using namespace std;

class Node 
{
public:
    string  m_name;
    int     m_age;    // age in years
    Node*   mp_next;  // pointer to next node
    
    Node() { m_name = "no name"; m_age = -1; mp_next = NULL; };
};

class MyLinkedList
{
    public:
        MyLinkedList();			// constructor
        ~MyLinkedList();			// destructor
        bool isEmpty() const;		// returns true if list is empty
        Node* findNode(string findName); // returns null or node w/ match
        void addNode(const Node& newNode);   // add node to list
        void removeFront();		// remove first node of list
        void remove(string name);
        void printList();
        void sort();
    private:
        Node* mp_startPtr;		// pointer to head of list
};

// ---------------------------------------------------------------------
// ---------------------------------------------------------------------
// end file
